<!-- card Header and  with TYPE and ID -->
[[#if customHeader]]
  [[#block "customHeader"]][[/block]]
[[else]]
<div data-flex-layout="row top-center" class="card-header">
    <div class="entity-card-color {{getValueByKey LINCStypeToCardColor allTypes 'lincs-rs-card-color-other'}}"></div>
    <div data-flex-self="left" class="d-flex rs-default-card__header-left">
      <span class="text-truncate" style="margin-left:4px;">{{directTypesLabels}}</span>
    </div>
  
    {{#if id}}
    <div data-flex-self="right" class="text-truncate rs-default-card__header-right">{{id}}</div>
    {{/if}}

    <button class="button-switch-{{serializeString iri}}" data-flex-self="right" style="border: none; background-color: white;">
        <i class="fa fa-eye flip-button"></i>
    </button>
</div>
[[/if]]

<!-- Card Image -->
<div class="rs-default-card__img-container {{getValueByKey entityBgColor allTypes 'rs-entity-bg-thing'}}">
    {{#if (hasKey allTypes "http://www.researchspace.org/ontology/EX_Digital_Image_Region")}}
        <rs-iiif-image-thumbnail height='480' width='640' style='height: 100%; width: 100%;'
          image-or-region='{{iri}}'      
          [[> rsp:IIIFConfig]]
        >
        </rs-iiif-image-thumbnail>

    {{else}}
      <mp-resource-thumbnail iri='{{iri}}' class='rs-default-card__img'>
          <mp-resource-thumbnail-fallback>
            <span class="rs-icon {{getValueByKey LINCStypeToImage allTypes 'lincs-rs-icon-default-no-img'}} {{getValueByKey entityIconColor allTypes 'rs-entity-icon-thing'}}"></span>
          </mp-resource-thumbnail-fallback>
      </mp-resource-thumbnail>
    {{/if}}       

</div>

<switch-button
  button-class="button-switch-{{serializeString iri}}"
  first-group-class="front-group-{{serializeString iri}}"
  second-group-class="back-group-{{serializeString iri}}">
  <!-- Card Footer with Object Titles (ja and English) and Artist -->
  <div class="rs-default-card__footer front-group-{{serializeString iri}}"
      style="padding:{{#if footer-paddingY}}{{footer-paddingY}}{{else}}11{{/if}}px {{#if footer-paddingX}}{{footer-paddingX}}{{else}}12{{/if}}px;">
      <div class="rs-default-card__footer-titles">
        [[#if customFooter]]
          [[#block "customFooter"]][[/block]]
        [[else]]
          {{#if label}}
            <span class="rs-body-s-M">{{label}}</span>
          {{else}}
            <mp-label iri='{{iri}}' class="rs-body-s-M" highlight='{{highlight}}' highlight-props='{"style": {"color": "#dc8a4b"}}'></mp-label>
          {{/if}}
        [[/if]]
      </div>
      <div class="entity-card-button-container">
        <div class="rs-default-card__hover-icon">
          <thinking-frame-check is-thinking-frame="true">
            <semantic-link-container uri='{{iri}}' target="_blank">
              <div class="rs-default-card__hover-button-wrapper">
                <button type="button" class="rs-button rs-entity-card-button" title="[[i18n 'view_basic' bundle='languages/resource_itemcardtemplatedefault' locale=this.lang]]">
                  <i class="rs-icon rs-icon-page rs-entity-card-icon"></i>
                </button>
                <p class="rs-body-s-M rs-entity-card-button-text">[[i18n "explore" bundle="languages/resource_itemcardtemplatedefault" locale=this.lang]]</p>
              </div>
            </semantic-link-container>
          </thinking-frame-check>
          <thinking-frame-check is-thinking-frame="false">
            <semantic-link-container uri='{{iri}}'>
              <div class="rs-default-card__hover-button-wrapper">
                <button type="button" class="rs-button rs-entity-card-button" title="[[i18n 'view_basic' bundle='languages/resource_itemcardtemplatedefault' locale=this.lang]]">
                  <i class="rs-icon rs-icon-page rs-entity-card-icon"></i>
                </button>
                <p class="rs-body-s-M rs-entity-card-button-text">[[i18n "explore" bundle="languages/resource_itemcardtemplatedefault" locale=this.lang]]</p>
              </div>
            </semantic-link-container>
          </thinking-frame-check>
        </div>

        [[#if (hasPermission "home:view-editor:*")]]
        <prod-hide>
          <div class="rs-default-card__hover-icon">
            <semantic-link-container uri='[[resolvePrefix "rsp:ThinkingFrames"]]' urlqueryparam-view="entity-editor" urlqueryparam-resource='{{iri}}'>
                <div class="rs-default-card__hover-button-wrapper">
                  <button type="button" class="rs-button rs-entity-card-button" title="[[i18n 'edit_resource' bundle='languages/resource_itemcardtemplatedefault' locale=this.lang]]">
                      <i class="fa fa-pencil rs-entity-card-icon"></i>
                  </button>
                  <p class="rs-body-s-M rs-entity-card-button-text">[[i18n "edit" bundle="languages/resource_itemcardtemplatedefault" locale=this.lang]]</p>
                </div>
            </semantic-link-container>
          </div>
        </prod-hide>
        [[/if]]

        <div class="rs-default-card__hover-icon">
            <semantic-link-container uri='[[resolvePrefix "rsp:ThinkingFrames"]]' urlqueryparam-view='knowledge-map' urlqueryparam-resource='{{iri}}' target="_blank">
                <div class="rs-default-card__hover-button-wrapper">
                  <button type="button" class="rs-button rs-entity-card-button" title="[[i18n 'explore_knowledge' bundle='languages/resource_itemcardtemplatedefault' locale=this.lang]]">
                    <i class="rs-icon rs-icon-diagram rs-entity-card-icon"></i>
                  </button>
                  <p class="rs-body-s-M rs-entity-card-button-text">[[i18n "map" bundle="languages/resource_itemcardtemplatedefault" locale=this.lang]]</p>
              </div>
            </semantic-link-container>
        </div>
      </div>
  </div>

  <!-- Back side of card -->
  <div class="rs-default-card__footer-back back-group-{{serializeString iri}}"
    style="padding:{{#if footer-paddingY}}{{footer-paddingY}}{{else}}11{{/if}}px {{#if footer-paddingX}}{{footer-paddingX}}{{else}}12{{/if}}px; display: none;">
    <div class="rs-default-card__back-container--scroll-auto">
        <semantic-query query='PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
                PREFIX lincs: <http://id.lincsproject.ca/>
                SELECT (<{{iri}}> as ?iri) ?graph
                WHERE { 
                            {
                            SELECT distinct ?typeLabel ?title where { 
                                graph <http://metadata.lincsproject.ca> {
                                    ?graph crm:P2_has_type ?status ;
                                      <http://www.cidoc-crm.org/cidoc-crm/P1_is_identified_by>  ?titleIdentifier .
                                    ?titleIdentifier <http://www.cidoc-crm.org/cidoc-crm/P2_has_type> <http://vocab.getty.edu/aat/300417227>  ;
                                      <http://www.cidoc-crm.org/cidoc-crm/P190_has_symbolic_content>  ?title .
                                }
                            GRAPH ?graph {
                                <{{iri}}> a ?type .
                            }
                          }
                  }
                  BIND(?title as ?graph)
                }	' template="{{> datasetsTemplate}}">
            <template id='datasetsTemplate'>
              <p class="entity-card_small-label-margin">[[i18n "dataset" bundle="languages/resource_itemcardtemplatedefault" locale=this.lang]]</p>
                {{#each bindings}}
                    {{#if @last}}
                    <p class="rs-body-s-M">{{graph.value}}</p>
                    {{else}}
                    <p class="rs-body-s-M rs-default-card__back-info--margin-small">{{graph.value}}</p>
                    {{/if}}
                {{/each}}
            </template>
        </semantic-query>

        <!-- BIRTH (IF AVAILABLE) -->
        <semantic-if
            query='ASK {
                        {<{{iri}}> <http://www.cidoc-crm.org/cidoc-crm/P98i_was_born> ?birth}
                        UNION
                        {?birth <http://www.cidoc-crm.org/cidoc-crm/P98_brought_into_life> <{{iri}}>}}'>
            <template id='then'>
                <p class="entity-card_small-label-margin">[[i18n "birth" bundle="languages/resource_itemcardtemplatedefault" locale=this.lang]]</p>
                <semantic-query query='
                PREFIX crm: <http://www.cidoc-crm.org/cidoc-crm/>
                PREFIX xsd: <http://www.w3.org/2001/XMLSchema#>
                
                SELECT ?birth (xsd:date(?date) as ?value)
                WHERE {
                  OPTIONAL {
                    <{{iri}}> crm:P98i_was_born ?birth ;
                            crm:P4_has_time-span ?time .
                    ?time crm:P82a_begin_of_the_begin ?date .   
                  }
                  OPTIONAL {
                    ?birth crm:P98_brought_into_life <{{iri}}> ;
                           crm:P4_has_time-span ?time .
                    ?time crm:P82a_begin_of_the_begin ?date .
                  }
                }' template='{{> birthTemplate }}'>
                      <template id="birthTemplate">
                          <p class="rs-body-s-M">{{bindings.0.value.value}}</p>
                      </template>
                </semantic-query>
            </template>
        </semantic-if>

        <!-- DEATH (IF AVAILABLE) -->
        <semantic-if query='ASK {
                        {<{{iri}}> crm:P100i_died_in ?death}
                        UNION
                        {?death crm:P100_was_death_of <{{iri}}>}}'>
            <template id='then'>
                <p class="entity-card_small-label-margin">[[i18n "death" bundle="languages/resource_itemcardtemplatedefault" locale=this.lang]]</p>
                <semantic-query query='
                PREFIX crm: <http://www.cidoc-crm.org/cidoc-crm/>
                PREFIX xsd: <http://www.w3.org/2001/XMLSchema#>
                
                SELECT ?death (xsd:date(?date) as ?value)
                WHERE {
                  OPTIONAL {
                    <{{iri}}> crm:P100i_died_in ?death ;
                            crm:P4_has_time-span ?time .
                    ?time crm:P82a_begin_of_the_begin ?date .   
                  }
                  OPTIONAL {
                    ?death crm:P100_was_death_of <{{iri}}> ;
                           crm:P4_has_time-span ?time .
                    ?time crm:P82a_begin_of_the_begin ?date .
                  }
                }' template='{{> deathTemplate }}'>
                    <template id='deathTemplate'>
                        <p class="rs-body-s-M">{{bindings.0.value.value}}</p>
                    </template>
                </semantic-query>
            </template>
        </semantic-if>

        <!-- P2_has_type -->
        <semantic-query query='
        PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
        SELECT (SAMPLE(?value) AS ?uri) (SAMPLE(?typeName) AS ?sampledTypeName) WHERE {
          <{{iri}}> <http://www.cidoc-crm.org/cidoc-crm/P2_has_type> ?value . 
          ?value rdfs:label ?typeName .
        }
        GROUP BY ?value
        ' template='{{> hasTypeTemplate }}'>
            <template id='hasTypeTemplate'>
                <p class="entity-card_small-label-margin">[[i18n "has_type" bundle="languages/resource_itemcardtemplatedefault" locale=this.lang]]</p>
                {{#each bindings}}
                <p class="rs-body-s-M rs-default-card__back-info--margin-small">{{sampledTypeName.value}}</p>       
                {{/each}}
            </template>
        </semantic-query>
    </div>
  </div>
</switch-button>